///////////////////////////////////////////////////////////
//  IEntity.cs
//  Implementation of the Interface IEntity
//  Generated by Enterprise Architect
//  Created on:      18-May-2018 16:18:46
//  Original author: simon.mettrick
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;



using Org.OMG.TACSIT.Controller;
using Org.OMG.TACSIT.Geometry;
namespace Org.OMG.TACSIT.Controller {
	public interface IEntity {

		/// <summary>
		/// Returns true if the given Entity corresponds to this Entity (i.e., the Tactical
		/// Objects are the same).
		/// </summary>
		/// <param name="entity"></param>
		bool Equals(Org.OMG.TACSIT.Controller.IEntity entity);

		/// <summary>
		/// Returns true if this instance is valid.
		/// </summary>
		bool IsValid();

		/// <summary>
		/// Returns the type of the Entity. This corresponds to the application specific
		/// class of the tactical object that has been added to the TACSIT.
		/// </summary>
		Org.OMG.TACSIT.Controller.IEntityType GetType();

		/// <summary>
		/// This is a convenience method for indicating whether the entity is to be handled
		/// as though it is a single point rather than a complex geometry. This is useful
		/// for containment and other queries.
		/// </summary>
		bool IsPointEntity();

		/// <summary>
		/// Returns the GeodeticPosition to be used as the main point of reference for this
		/// entity.
		/// </summary>
		Org.OMG.TACSIT.Geometry.IGeodeticPosition GetReferencePoint();
	}//end IEntity

}//end namespace Controller